function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import { useEffect, useLayoutEffect, useState } from 'react';
/**
 * 监听 document.body 尺寸变化
 * @returns
 */

export function useBodyResize() {
  var _document$body = document.body,
      clientWidth = _document$body.clientWidth,
      clientHeight = _document$body.clientHeight;

  var _useState = useState([clientWidth, clientHeight]),
      _useState2 = _slicedToArray(_useState, 2),
      size = _useState2[0],
      setSize = _useState2[1];

  useLayoutEffect(function () {
    function updateSize() {
      var _document$body2 = document.body,
          cw = _document$body2.clientWidth,
          ch = _document$body2.clientHeight;
      setSize([cw, ch]);
    } // updateSize();


    window.addEventListener('resize', updateSize);
    return function () {
      window.removeEventListener('resize', updateSize);
    };
  }, []);
  return size;
}
export function useElementResize(_ref) {
  var el = _ref.el,
      onResize = _ref.onResize,
      _ref$deps = _ref.deps,
      deps = _ref$deps === void 0 ? [] : _ref$deps;

  // 实例
  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      obs = _useState4[0],
      setObs = _useState4[1];

  useEffect(function () {
    if (deps.every(Boolean)) {
      setObs(new ResizeObserver(function (entries) {
        // 分发
        entries.forEach(function (entry) {
          onResize === null || onResize === void 0 ? void 0 : onResize.call(null, entry);
        });
      }));
    }
  }, deps);
  useEffect(function () {
    if (el && obs) {
      // 开始监听
      obs.observe(el);
    }
  }, [el, obs]); // 销毁

  useEffect(function () {
    return function () {
      return obs === null || obs === void 0 ? void 0 : obs.disconnect();
    };
  }, [obs]);
}